{$ignore-function-results}
{$w no-underscore}

program testmouse(output);
{ Test ncurses for f key and mouse input  }
{ Mouse works only on xterminal (x11 etc) }
{ compile for GPC:   gp testmouse.pas
}

uses ncurses;

type
  string80 = string[80];
var
  c1, c2: chtype; { chtype is the ncurses "char" type (actually integer) returned by getch etc }
  i, line, col: integer;
  linecount, colcount: cint; { cint type is imported from ncurses.pas  }
  MEVENTPtr: pMEVENT;
  MMask: mmask_t;
  MouseMaskPtr: pmmask_t;
  str: string[80];

function IsFKey(c: chtype): boolean;
{ return true iff c is a function key, }
begin
  IsFKey :=  ( c >=  KEY_MIN ) AND ( c<= KEY_MAX );
end { IsFKey };

function KeyNameClean(c: chtype): pchar;
  { return a user-friendly key name, e.g. "KEY_F(2)"  => "F2" ;  Meta-A not garbled  }
var sx: string[120]; ix: integer;
begin
  if (c > 127) and (c < 256) 
    then sx := 'M-' + CString2String(unctrl(c mod 128))
    else
      begin
        sx := CString2String(keyname(c));
        ix :=  index(sx,'KEY_');
        if (ix=1) and (length(sx)>4) then sx :=  substr(sx,5);
        ix := index(sx,'(');
        if (ix>1) and (ix+1<length(sx)) then 
          begin  
            sx := sx[1..ix-1] + sx[ix+1..length(sx)];  { trim the "(" }
            if sx[length(sx)] = ')' then sx :=substr(sx,1,length(sx)-1);
          end;
     end;
  KeyNameClean := sx;
end { UserKeyName };

procedure AddInt(cc: integer);
{ puts a three-digit integer in the output buffer }
begin
        addch(ord('0') + cc div 100);
        cc :=  cc mod 100;
        addch(ord('0') + (cc div 10) );
        cc := cc mod 10;
        addch(ord('0') + (cc ) );
end { AddInt };


begin
  writeln('preliminary test of constants');
  writeln('BUTTON1_RELEASED      =MedCard(8#000000000001)  = ', BUTTON1_RELEASED )  ;
  writeln('BUTTON1_PRESSED       =MedCard(8#000000000002)  = ', BUTTON1_PRESSED ) ;        
  writeln('BUTTON1_DOUBLE_CLICKED=MedCard(8#000000000010)  = ',BUTTON1_DOUBLE_CLICKED  );
  writeln('ALL_MOUSE_EVENTS      =MedCard(8#000777777777)  = ',ALL_MOUSE_EVENTS     );
  writeln;
  writeln('About to set up ncurses ..'); { if setup fails, this stays on screen }
  writeln('Note: ncurses mouse works only with xterm emulator, NOT just "set term=xterm".');
  writeln('Press RETURN, and you will enter RAW mode...  exit as instructed (no exit via ^C)');
  readln;
{ ncurses initialization }
   initscr;
   clear; { initscr also clears in most, not all, implementations }
   noecho;
   { cbreak; }    { No line buffering, pass on as typed including erase, but process ^C and ^Z }
   raw;   { raw additionally does not interpret interrupt, quit, suspend, and flow control  characters }
   keypad(stdscr, true);  { enable ncurses' recognition of F keys }
{ create structures pointed to by mouse pointers }
{ mask version }
   new(MouseMaskPtr);
   new(MEVENTPtr);
   MMask := mousemask(ALL_MOUSE_EVENTS, MouseMaskPtr);   

  { set version 
   new(BSSetPtr);
   BSSetOld := mousemasks(AllMouseEvents, BSSetPtr);
}
   move(1,1);
   getbegyx(stdscr, linecount, colcount);
   addstr('begin line, begin col = ');AddInt(linecount); addstr(', '); AddInt(colcount); refresh;
   getmaxyx(stdscr, linecount, colcount);
   move(0,0);
  addstr('termname="');
  addstr(termname); addstr('"  ');
   addstr('linecount, colcount = ');  AddInt(linecount); addstr(', '); AddInt(colcount); refresh;
   c2 := getch; { pause for user }
   clear;
   move(0,0); { line, col, both zero-origin }
   addstr('type chars, F keys, mouse; "M" meta on, "m" meta off; u=ungetmouse, "q" to quit: ');
   refresh;
   repeat
     c1 := getch;
     move(1,0); clrtoeol;  addstr('Is F Key=');
     if IsFKey(c1) then addstr('True  ') else addstr('False ');
     addstr('keynameClean="');  
     addstr(KeyNameClean(c1));
     addstr('"   value='); AddInt(c1);
     addstr('   chr="'); addch(c1); addstr('" ');
     if c1 = ord('M') then meta(stdscr,true)
     else if c1 = ord('m') then meta(stdscr,false)
     else if c1 = ord('u') then begin
          with MEventPtr^ do begin x := 5; y:= 15; end; 
          if (ungetmouse(MEventPtr) <> Curses_OK) 
               then writeln(' error in mouse unget ');
          end;
     if c1 = KEY_MOUSE then
       begin
        refresh;
        if (getmouse(MEVENTPtr) = Curses_OK) then
           begin
             move(3,0); clrtoeol;
             addstr('Mouse click at x='); AddInt(MEVENTPtr^.x);
             addstr(',  y='); AddInt(MEVENTPtr^.y);
             move(4,0); clrtoeol;
             addstr('Event was :');
             writestr(str,MEVENTPtr^.bstate:12); addstr(str); 
           end;
       end;
    refresh; 
   until ord('q') = c1;
   { last info should be left on screen }
   endwin; 
end.

